<template>
  <div>
    <h1 class="header_tab">Restaurants Map</h1>

    <b-container fluid="md" class="input_con">
      <b-row>
        <b-col col lg="2"></b-col>
        <b-col col lg="8">
          <b-row>
            <b-icon class="input_icon" icon="search"></b-icon>
            <gmap-autocomplete
              @place_changed="initMarker"
              class="input_text"
            ></gmap-autocomplete>
            <b-button
              @click="addLocationMarker"
              variant="outline-success"
              class="button_text"
              >Get Location</b-button
            >
          </b-row>
        </b-col>
        <b-col col lg="2"></b-col>
      </b-row>
    </b-container>

    <b-container fluid="md">
      <b-row>
        <b-col>
          <gmap-map :zoom="16" :center="center" class="map_style" ref="mapRef">
            <gmap-marker
              :key="index"
              v-for="(m, index) in locationMarkers"
              :position="m.position"
              @click="center = m.position"
            ></gmap-marker>
          </gmap-map>
        </b-col>
      </b-row>
    </b-container>

    <b-container class="list_card">
      <b-row>
        <b-col cols="4" :key="index" v-for="(m, index) in locationMarkers">
          <b-card
            :title="m.title"
            text
            img-src="https://images.unsplash.com/photo-1414235077428-338989a2e8c0?ixlib=rb-4.0.3&ixid=MnwxMjA3fDB8MHxwaG90by1wYWdlfHx8fGVufDB8fHx8&auto=format&fit=crop&w=2070&q=80"
            img-alt="Image"
            img-top
            tag="article"
            style="max-width: 20rem"
            class="card_style"
          >
            <b-card-text>
              {{ m.vicinity }}
            </b-card-text>
          </b-card>
        </b-col>
      </b-row>
    </b-container>

    <h1 class="end_tab">Create web by Guide</h1>
  </div>
</template>

<script>
import { gmapApi } from "vue2-google-maps"; //for search nearby restaurants

export default {
  name: "GoogleMap",

  //parameter data
  data() {
    return {
      currentLocation: {},
      circleOptions: {},
      pins: {
        selected: "",
        notSelected: "",
      },
      mapStyle: [],
      clusterStyle: [
        {
          url: "https://developers.google.com/maps/documentation/javascript/examples/markerclusterer/m1.png",
          width: 56,
          height: 56,
          textColor: "#fff",
        },
      ],
      center: {
        lat: 13.8268187,
        lng: 100.528235,
      },
      locationMarkers: [],
      locPlaces: [],
      existingPlace: null,
      markers: [],
    };
  },

  // for search nearby
  computed: {
    google: gmapApi,
  },

  created() {
    this.locateGeoLocation();
    this.getCurrentPositionandBathroom();
  },

  methods: {

    //input place for search
    initMarker(loc) {
      this.existingPlace = loc;
    },

    //mark place input
    addLocationMarker() {
      if (this.existingPlace) {
        this.center = {
          lat: this.existingPlace.geometry.location.lat(),
          lng: this.existingPlace.geometry.location.lng(),
        };
        this.locPlaces.push(this.existingPlace);
        this.existingPlace = null;
        this.locationMarkers = [];
      }
      this.getBathroom();
    },

    //go to mark locate input
    locateGeoLocation: function () {
      navigator.geolocation.getCurrentPosition((res) => {
        this.center = {
          lat: res.coords.latitude,
          lng: res.coords.longitude,
        };
      });
    },

    getCurrentPositionandBathroom() {
      if (process.client) {
        if (!navigator.geolocation) {
          alert("Japanese sentences");
          return;
        }
        navigator.geolocation.getCurrentPosition(this.success, this.error);
      }
    },

    // nearby search type restaurant
    getBathroom() {
      const map = this.$refs.mapRef.$mapObject;
      const placeService = new this.google.maps.places.PlacesService(map);
      placeService.nearbySearch(
        {
          location: new this.google.maps.LatLng(
            this.center.lat,
            this.center.lng
          ),
          radius: 800,
          type: ["restaurant"],
        },
        function (results, status) {
          if (status === this.google.maps.places.PlacesServiceStatus.OK) {
            results.forEach((place) => {
              const marker = {
                position: {
                  lat: place.geometry.location.lat(),
                  lng: place.geometry.location.lng(),
                },
                title: place.name,
                id: place.place_id,
                rating: place.rating,
                photo: place.photos ? place.photos[0].html_attributions[0] : "",
                vicinity: place.vicinity,
              };
              this.locationMarkers.push(marker);
            });
          }
        }.bind(this)
      );
    },

    success(position) {
      this.center.lat = position.coords.latitude;
      this.center.lng = position.coords.longitude;
    },
    error(errorMessage) {
      switch (errorMessage.code) {
        case 1:
          alert("Japanese sentences");
          break;
        case 2:
          alert("Japanese sentences");
          break;
        case 3:
          alert("Japanese sentences");
          break;
        default:
          alert("Japanese sentences");
          break;
      }
    },

  },
};
</script>

<style scoped>
.header_tab {
  background-color: rgba(146, 213, 146, 0.833);
  text-align: center;
  font-size: 34px;
  height: 80px;
  margin: auto;
  padding: 16px;
}
.end_tab {
  background-color: rgba(146, 213, 146, 0.833);
  text-align: center;
  font-size: 26px;
  height: 60px;
  margin: auto;
  padding: 14px;
}
.input_text {
  border-color: rgb(146, 213, 146, 0.833);
  border-radius: 20px;
  text-align: center;
  margin: 18px 8px 18px 120px;
  padding: 18px 120px 18px 120px;
}
.input_icon {
  position: absolute;
  margin: auto;
  padding: 40px 0px 0px 130px;
}
.button_text {
  border-radius: 20px;
  margin: 18px 0px 18px 0px;
  padding: 18px 10px 18px 10px;
}
.input_con {
  position: center;
  margin: auto;
  padding: 30px 0px 30px 0px;
}
.map_style {
  height: 500px;
  margin: auto;
  padding: 50px 0px 50px 0px;
}
.list_card {
  justify-content: space-around;
  padding: 20px 0px 20px 0px;
}
.card_style {
  margin: 10px 0px 20px 22px;
}
</style>
